//**********************************************************
// **** MAIN routine FOR Interfacing microSD/SD CARD ******
//**********************************************************
//Controller: ATmega128(16 Mhz internal)
//Compiler	: AVR-GCC
//********************************************************

//Link to the Post: http://www.dharmanitech.com/2009/01/sd-card-interfacing-with-atmega8-fat32.html

#define F_CPU 16000000UL		//freq 8 MHz
#include <avr/io.h>
#include <avr/pgmspace.h>
#include <avr/interrupt.h>
#include "UART_routines.h"

#include "tftlcd.h"

//#include "image.h"
#include "touch.h"


#include "SD_card.h"
#include "SD_FAT32.h"


void TFT_filenumber(void);			// display file number
void TFT_filename(U08 file_number);		// display BMP file name
void TFT_display_BMP(U32 sector);		// display BMP file of SD card


volatile unsigned int timer = 0;		// 1 sec counter

unsigned char total_file;			// total file number
unsigned char file_number = 0;			// current file number
unsigned char BMP_type;				// BMP image type(P=portrait, L=landscape)





ISR(TIMER1_COMPA_vect)				/* OC1A interrupt function */
{
  timer++;
}





//*************************** MAIN *******************************//
int main(void)
{
//unsigned char option, error, data, FAT32_active;
//

//unsigned int i, x, y, color;
   
  unsigned char i; 
 
  unsigned char display_flag = 1;		// new screen display flag
  unsigned char filename_flag = 1;		// file name display flag

  unsigned long BMP_start_sector[MAX_FILE];	// BMP file start sector


 init_devices();

 //PORTD |= 0x04; //switching ON the LED (for testing purpose only)
 //C2003_Setup();
 TFT_SET();

Initialize_TSC2003();
 Initialize_SPI();				// initialize SPI
 Initialize_SD();				// initialize SD card
 Initialize_FAT32();				// initialize FAT32 file system

 //TFT_clear_screen();
  //LCD_Clear(); 
 /*
  LCD_WR_REG16(0x0022);  
 Demo_display_8_color();

delay_ms(500);  delay_ms(500);
delay_ms(500);  delay_ms(500);
delay_ms(500);  delay_ms(500);
delay_ms(500);  delay_ms(500);

TFT_color_screen(Green);
*/

 TX_NEWLINE;
 TX_NEWLINE;
 transmitString_F (PSTR("****************************************************"));
 TX_NEWLINE;
 transmitString_F (PSTR("   Signaltech microSD Card Testing.  "));
 TX_NEWLINE;
 transmitString_F (PSTR("****************************************************"));
 TX_NEWLINE;
  
 TFT_clear_screen();
Demo_display_8_color();




TFT_clear_screen();
 
    TCCR1A = 0x00; 
    TCCR1B = 0x0C;      //  timer/counter1 regB  16MHz/256/(1+62499) = 1Hz
    TCCR1C = 0x00;  //timer/counter1 reg C
 
	TCNT1 = 0;						// 255-156 = 99	
	OCR1A= 62499;           //0x00;
	TIMSK = 0x02;						// TIMER0 ͷƮ 㰡
TIFR=0x2F;
 sei();


/*
//TFT_display_BMP(BMP_start_sector[1]);
  TFT_string(10,1,WHITE,  Transparent,"    test  ");
  total_file = fatGetDirEntry(FirstDirCluster);	// get total file number
  for(i = 0; i < total_file; i++)		// get start address of all files
    BMP_start_sector[i] = fatClustToSect(file_start_cluster[i]);
 file_number = 0;

  TFT_string(10,5,RED,    Transparent,"   Red ");

//TFT_display_BMP(BMP_start_sector[1]);
TFT_string(2,5,YELLOW,  Transparent,"1234567890!@");  //50

delay_ms(500);  delay_ms(500);
delay_ms(500);  delay_ms(500);
*/



while(1)

{

Touch_input_TSC2003();	

 TFT_color(Cyan,Black);
      TFT_xy(21,14);				// display 12-bit original X data
      TFT_unsigned_decimal(x_12bit,0,4);
      TFT_xy(21,16);				// display 12-bit original Y data
      TFT_unsigned_decimal(y_12bit,0,4);
      TFT_xy(21,20);				// display pixel X data 
      TFT_unsigned_decimal(x_touch,0,3);
      TFT_xy(21,22);				// display pixel Y data
      TFT_unsigned_decimal(y_touch,0,3);

      if((x_touch >= 76) && (x_touch <= 164) && (y_touch >= 220) && (y_touch <= 244))
        { 
          delay_ms(200);
        }
      else if((x_touch >= 76) && (x_touch <= 164) && (y_touch >= 252) && (y_touch <= 276))
        {
          delay_ms(200);
	}    

      delay_ms(20);
/*
//TFT_display_BMP(BMP_start_sector[file_number]);


	if(display_flag == 1)			// display BMP file, file number, and file name
        { Get_long_filename(file_number);	// check file name
	  if(extension != 0x00424D50)		// if not BMP file, skip
            { if(file_number < (total_file - 1))
	        file_number++;
	      else
	        file_number = 0;
	    }
          else					// if BMP file, display
	    { TFT_display_BMP(BMP_start_sector[file_number]);
              if(filename_flag == 1)
  	        { TFT_filenumber();
	          TFT_filename(file_number);
	        }
	      display_flag = 0;
              timer = 0;
	    }
	}

      if(timer >= 5)				// go next file by 5 sec step
	{ if(file_number < (total_file - 1))            
	    file_number++;
	  else
	    file_number = 0;
	  display_flag = 1;
        }

*/

  } //While

}  //main  

/*
      Touch_input_TSC2003();			// input touch screen

      if((x_touch != 0) && (y_touch != 0))
	{ Beep();
	  if(file_number < (total_file - 1))	// if touch screen input, go next file
	    file_number++;
	  else
	    file_number = 0;

	  display_flag = 1;
	} 

 }
*/



/*

      switch(Key_input())			// key input
        { case KEY1: if(file_number > 0)	// if KEY1, go previous file
		       file_number--;
		     else
		       file_number = total_file - 1;
		     display_flag = 1;
		     break;

          case KEY2: if(file_number < (total_file - 1))	// if KEY2, go next file
		       file_number++;
		     else
		       file_number = 0;
		     display_flag = 1;
		     break;

          case KEY3: filename_flag ^= 0x01;	// file name display ?
		     if(filename_flag == 1)
		       { TFT_filenumber();
	                 TFT_filename(file_number);
		       }
		     else
		       TFT_display_BMP(BMP_start_sector[file_number]);
		     break;

          case KEY4: play_flag ^= 0x01;		// go or stop ?
		     if(play_flag == 1) cli();
		     else               sei();	
		     break;

          default:   break;
        }



*/



void TFT_filenumber(void)			/* display file number */
{
  TFT_screen_mode(BMP_type);			// screen mode(Portrait or Landscape)

  TFT_xy(0,0);					// start position and color
  TFT_color(White, Transparent);

  TFT_English('(');
  TFT_unsigned_decimal(file_number+1,1,2);	// current file number
  TFT_English('/');
  TFT_unsigned_decimal(total_file,1,2);		// total file number
  TFT_English(')');
}


void TFT_filename(U08 file_number)		/* display BMP file name */
{

  unsigned char file_flag;

   file_flag = Get_long_filename(file_number);	// check file name

  if(file_flag == 0)				// short file name(8.3 format)
   TFT_short_filename(8,0,Yellow,Transparent);
  else if(file_flag == 1)			// long file name
   TFT_long_filename(8,0,Yellow,Transparent);
  else if(file_flag == 2)			// file name is longer than 195 characters
    TFT_string(8,0,White,Transparent,"* ϸ  ʰ *");
  else						// file name error
    TFT_string(8,0,White,Transparent,"*** ϸ  ***");

}




/* ---------------------------------------------------------------------------- */

struct BMP_header{				/* Header 14 bytes + InfoHeader 40 bytes */
 unsigned char signature[2];			// 'BM'
 unsigned long file_size;			// file size in bytes
 unsigned long reserved;			// unused (= 0)
 unsigned long data_offset;			// file offset to Raster Data

 unsigned long size;				// size of InfoHeader (= 40)
 unsigned long width;				// bitmap width
 unsigned long height;				// bitmap height
 unsigned int  planes;				// number of planes (= 1)
 unsigned int  bit_count;			// bits per pixel 
 unsigned long compression;			// type of compression   
 unsigned long image_size;			// size of image
 unsigned long x_pixels_per_m;			// horizontal resolution(pixels/meter)
 unsigned long y_pixels_per_m;			// vertical resolution(pixels/meter)
 unsigned long colors_used;			// number of actually used colors
 unsigned long colors_important;		// number of important colors. 0 = all
};

// Description : SD ī忡  BMP ̹  TFT-LCD ϱ
// sector = BMP ̹ ִ Ͻ ͹ȣ
//
//         [B]         [G]       [R]
//          5           6         5
//       11111000   11111100   11111000
//          &           &         &
//        buf[0]      buf[1]    buf[2]
//
//         >> 3        << 3      << 8 (BGR ¸ RGB · ٽ 迭)
//
//          [R]         [G]        [B]
// pixel = ?????      ??????      ????? = 16 bit

void TFT_display_BMP(U32 sector)		/* display BMP file of SD card */
{
  unsigned char buffer_control;
  unsigned int  i, pixel, sector_cnt;
  unsigned char BMPbuffer[512];   		// BMP data from SD card

  struct BMP_header *bmp_ptr;

  SD_read_sector(sector, BMPbuffer);		// read sector of BMP header

  bmp_ptr = (struct BMP_header *)BMPbuffer;

  if(bmp_ptr->width == 240)			// if 240*320, Portrait screen(bottom --> top)
    { BMP_type = 'P';  //p
  
  
  LCD_WR_REG(0x0003,0x1010); // set GRAM write direction and BGR=1.
  LCD_WR_REG(0x0020,0x0000);  //  x=0
  LCD_WR_REG(0x0021,0x013F);  //  y=319
/*
   // Memory access
  LCD_WR_REG(0x0050,0x0000); // Horizontal GRAM Start Address
  LCD_WR_REG(0x0051,0x0000); // Horizontal GRAM End Address
  LCD_WR_REG(0x0052,0x0000); // Vertical GRAM Start Address
  LCD_WR_REG(0x0053,0x0000); // Vertical GRAM Start Address 
  
  */
  LCD_WR_REG16(0x0022); 


    }
  else if(bmp_ptr->width == 320)		//     if 320*240, Landscape screen(left --> right)
    { BMP_type = 'L';  //l

  LCD_WR_REG(0x0003,0x1038); // set GRAM write direction and BGR=1.
  LCD_WR_REG(0x0020,0x0000); // x=0
  LCD_WR_REG(0x0021,0x0000); // y=0
  LCD_WR_REG16(0x0022);  
  

    }

  for(i = 0x36; i <= 509; i += 3)
    { pixel  = (BMPbuffer[i] & 0xf8) >> 3;	// Blue
      pixel |= (BMPbuffer[i+1] & 0xfc) << 3;	// Green
      pixel |= (BMPbuffer[i+2] & 0xf8) << 8;	// Red
      LCD_WR_DATA16(pixel);
    }
  sector++;
  buffer_control = 1;

  for(sector_cnt = 0; sector_cnt <= 449; sector_cnt++)	// read next sector and output RGB data
    {
      switch (buffer_control)			// rotate case 1, 2, 3
	{ case 1: pixel  = (BMPbuffer[510] & 0xF8) >> 3;
		  pixel |= (BMPbuffer[511] & 0xFC) << 3;
		  SD_read_sector(sector, BMPbuffer);
		  pixel |= (BMPbuffer[0] & 0xF8) << 8;
		  LCD_WR_DATA16(pixel);

		  for(i = 1; i <= 509; i += 3)
		    { pixel  = (BMPbuffer[i] & 0xf8) >> 3;
		      pixel |= (BMPbuffer[i+1] & 0xfc) << 3;
		      pixel |= (BMPbuffer[i+2] & 0xf8) << 8;
		      LCD_WR_DATA16(pixel);
		    }
		  sector++;
		  buffer_control = 2;
		  break;

	  case 2: pixel  = (BMPbuffer[511] & 0xF8) >> 3;
		  SD_read_sector(sector, BMPbuffer);
		  pixel |= (BMPbuffer[0] & 0xFC) << 3;
		  pixel |= (BMPbuffer[1] & 0xF8) << 8;
		  LCD_WR_DATA16(pixel);

		  for(i = 2; i <= 509; i += 3)
		    { pixel  = (BMPbuffer[i] & 0xF8) >> 3;
		      pixel |= (BMPbuffer[i+1] & 0xFC) << 3;
		      pixel |= (BMPbuffer[i+2] & 0xF8) << 8;
		      LCD_WR_DATA16(pixel);
		    }
		   sector++;
		   buffer_control = 3;
		   break;

	  case 3: SD_read_sector(sector, BMPbuffer);
		  if(sector_cnt != 449)
		    { for(i = 0; i <= 509; i += 3)
			{ pixel  = (BMPbuffer[i] & 0xF8) >> 3;
			  pixel |= (BMPbuffer[i+1] & 0xFC) << 3;
			  pixel |= (BMPbuffer[i+2] & 0xF8) << 8;
			  LCD_WR_DATA16(pixel);
			}
		    }
		  else				// if last sector, read 54 bytes only
		    { for(i = 0; i < 54; i += 3)
			{ pixel  = (BMPbuffer[i] & 0xF8) >> 3;
			  pixel |= (BMPbuffer[i+1] & 0xFC) << 3;
			  pixel |= (BMPbuffer[i+2] & 0xF8) << 8;
			  LCD_WR_DATA16(pixel);
			}
		    }
		  sector++;
		  buffer_control = 1;
		  break;
	}
    }

  LCD_WR_REG(0x0003,0x1030); // set GRAM write direction and BGR=1.

}


void port_init(void)
{
   DDRA=0xff;
   PORTB = 0xFE;
   DDRB  = 0xF7;
////MISO line i/p, rest o/p
    DDRC=0xff;
    DDRD=0xfB;
	DDRE=0x7f;
	DDRF=0xff;

	PORTD= 0xff;
	PORTE= 0xff;
}

//UART0 initialize
// desired baud rate: 19200
// actual: baud rate:19231 (0.2%)
// char size: 8 bit
// parity: Disabled
void uart0_init(void)
{

  UBRR0H = 0;                                   //8M => 19200, 16M => 38400 bps
  UBRR0L = 25;
  UCSR0A = 0x00;                                // asynchronous normal mode
  UCSR0B = 0x18;                                // interrupt enable, 8 data
  UCSR0C = 0x06;                                // no parity, 1 stop, 8 data

 /*UCSR0B = 0x00; //disable while setting baud rate
 UCSR0A = 0x00;
 UCSR0C = (1 << UMSEL0) | 0x06;
 UBRR0L = 0x19; //set baud rate lo
 UBRR0H = 0x00; //set baud rate hi
 UCSR0B = 0x18;
*/
}

//call this routine to initialize all peripherals
void init_devices(void)
{
 
 port_init();
 uart0_init();
// Timer/Counter0 (Overflow)
   
/*
  TCCR1A = 0x00;      // timer/counter1 regA CTC mode(4), don't output OC1A
  TCCR1B = 0x0C;      //  timer/counter1 regB  16MHz/256/(1+62499) = 1Hz
  TCCR1C = 0x00;  //timer/counter1 reg C
  OCR1A = 62499; //output compare regA1
  TCNT1 = 0x0000;  //timer/counter1

  TIMSK1 = 0x02;        //timer/counter1  enable OC1A interrupt
  TIFR1 = 0x2F;         // clear all interrupt flags
  */
 
}
