/* ---------------------------------------------------------------------------- */
/*		OK-TFT32X  TSC2003 ġ ũ Ʈѷ Է Լ		*/
/* ---------------------------------------------------------------------------- */

//#define IRQ_I2C		0b01000000		// PE6(INT6) = -IRQ_I2C from TSC2003 -PENIRQ

#define TSC2003_CMD_X	0b11000000		// 12-bit X position measurement command
#define TSC2003_CMD_Y	0b11010000		// 12-bit Y position measurement command




#define x_touch_min	250			// minimum value of touch screen x-axis
#define x_touch_max	3750			// maximum value of touch screen x-axis
#define y_touch_min	400			// minimum value of touch screen y-axis
#define y_touch_max	3830			// maximum value of touch screen y-axis

unsigned int Touch_X = 0,Touch_Y = 0;			// x_12bit(0-4095), y_12bit(0-4095)
unsigned int x_touch, y_touch;			// x_touch(0-239), y_touch(0-319)



void Initialize_TSC2003(void);			// initialize TSC2003
unsigned int Read_TSC2003(U08 command);		// read X, Y value from TSC2003
void Touch_input_TSC2003();			// touch input X, Y average value from TSC2003



void Initialize_TSC2003(void)			/* initialize TSC2003 */
{
// TWI(I2c) setup
	TWBR = 0x0c;							// Bit Rate: 400.000 kHz
	TWDR = 0xff;							// TWI DATA = 0xff
	TWSR = 0x00;							//  Clear , prescaler = 00(1)

// TSC2003 setup
	TSC2003_Write(0x38);						// PENIRQ ready mode
}


// ================================ TSC2003 Write ============================
// [μ] unsigned char datau
// Item1:  
// ---------------------------------------------------------------------------
void TSC2003_Write(unsigned char datau)
{
	TWCR = 0xa4;							// START
	while(((TWCR & 0x80) == 0x00) || ((TWSR & 0xf8) != 0x08));	
	TWDR = 0x90;							// Address 0 + write
	TWCR = 0x84;							// TWINT 1 Ἥ Ŭ
	while(((TWCR & 0x80) == 0x00) || ((TWSR & 0xf8) != 0x18));	
	TWDR = datau;							// data ۽
	TWCR = 0x84;							// TWINT 1 Ἥ Ŭ
	while(((TWCR & 0x80) == 0x00) || ((TWSR & 0xf8) != 0x28));

	TWCR = 0x94;							// Ϸ 
}


// =============================== TSC2003 word Read =========================
// [μ] unsigned char cmd
// Item1: ġ  command 
// ---------------------------------------------------------------------------
unsigned TSC2003_Word_Read(unsigned char cmd)
{
unsigned char byte;
unsigned rdatau = 0;

	TWCR = 0xa4;							// START
	while(((TWCR & 0x80) == 0x00) || ((TWSR & 0xf8) != 0x08));	
	TWDR = 0x90;							// Address 0 + write
	TWCR = 0x84;							// TWINT 1 Ἥ Ŭ
	while(((TWCR & 0x80) == 0x00) || ((TWSR & 0xf8) != 0x18));	
	TWDR = cmd;							// cmd data ۽
	TWCR = 0x84;							// TWINT 1 Ἥ Ŭ
	while(((TWCR & 0x80) == 0x00) || ((TWSR & 0xf8) != 0x28));
  
	TWCR = 0xa4;							// START
	while(((TWCR & 0x80) == 0x00) || ((TWSR & 0xf8) != 0x10));	//  ?
	TWDR = 0x91;   							// Address 0 + read   
	TWCR = 0x84;							// TWINT 1 Ἥ Ŭ    
	while(((TWCR & 0x80) == 0x00) || ((TWSR & 0xf8) != 0x40));	// SLA-R Ϸ?
	TWCR = 0xc4;							// data read
	while(((TWCR & 0x80) == 0x00) || ((TWSR & 0xf8) != 0x50));	// data  ACK?
	rdatau = TWDR;
	TWCR = 0x84;							// TWINT 1 Ἥ Ŭ    
	while(((TWCR & 0x80) == 0x00) || ((TWSR & 0xf8) != 0x58));	// data  ACK?
	byte = TWDR;

	TWCR = 0x94;							// Ϸ           	

	rdatau =  (rdatau << 4) & 0x0ff0;				// D11-D4
	rdatau |= (unsigned)((byte >> 4) & 0x0f);			// D3-D0	

	return rdatau;
}






void Touch_input_TSC2003(void)			/* touch input X, Y average value from TSC2003 */
{
  unsigned char i;
int x,y;

  
for(i = 0; i < 16; i++)			// read X, Y value by 16 times if -PENIRQ enable
    { if((PIND & 0x04) == 0x00)		// -IRQ= 0 ?
        Touch_X +=  TSC2003_Word_Read(0xc0);	// if yes, measure X position
      else					// if not, return with 0
        { Touch_X = 0;
	      Touch_Y = 0;
	  break;
	}
      delay_us(10);

      if((PIND & 0x04) == 0x00)		// -IRQ= 0 ?
        Touch_Y += TSC2003_Word_Read(0xd0);// if yes, measure Y position
      else					// if not, return with 0
        { Touch_X = 0;
	      Touch_Y = 0;
	  break;
	}
      delay_us(10);
    }
 Touch_X >>= 4;				// calculate average for 16 times
 Touch_Y >>= 4;


 if(Touch_X <= x_touch_min)			// convert to pixel x-axis value
    x_touch = 0;
  else if(Touch_X >= x_touch_max)
    x_touch = 239;
  else
    x_touch = (unsigned int)((float)(Touch_X - x_touch_min) * 239./(float)(x_touch_max - x_touch_min));

  if(Touch_Y <= y_touch_min)			// convert to pixel y-axis value
    y_touch = 0;
  else if(Touch_Y >= y_touch_max)
    y_touch = 319;
  else
    y_touch = 319 - (unsigned int)((float)(Touch_Y - y_touch_min) * 319./(float)(y_touch_max - y_touch_min));




/*
  if(Touch_X <= x_touch_min)			// convert to pixel x-axis value
    x_touch = 0;
  else if(Touch_X >= x_touch_max)
    x_touch = 239;
  else
    x_touch = (unsigned int)((float)(Touch_X - x_touch_min) * 239./(float)(x_touch_max - x_touch_min));

  if(Touch_Y <= y_touch_min)			// convert to pixel y-axis value
    y_touch = 0;
  else if(Touch_Y >= y_touch_max)
    y_touch = 319;
  else
    y_touch = 319 - (unsigned int)((float)(Touch_Y - y_touch_min) * 319./(float)(y_touch_max - y_touch_min));
*/
}











